<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use Carbon\Carbon;
use App\Http\Providers\iam\core\model\OracleOCIConnector;

class StgpelniprintModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "stg_pelni_pr_int";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "stgpelniprint";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "preparer_name",
        "destination_type_code",
        "org_id",
        "req_number_segment1",
        "apprver_name",
        "interface_source_code",
        "authorization_status",
        "document_type_code",
        "source_type_code",
        "item_id",
        "item_segment1",
        "need_by_date",
        "quantity",
        "flagsync",
        "id",
        "creation_date",
        "subinventory",
        "voyage_call",
        "total_line",
        "header_attribute14",
        "header_attribute10",
        "header_attribute9"


    ];

    public static function prepareSaveToOracle()
    {
        $start = 0;
        $limit = 100;
        $nRepeat = 0;
        (new LogsyncoracleModel)->setLogSync("Permintaan Barang - PR", Carbon::now()->toDateTimeString(), "", "start");
        do {
            $stagings = (new StgpelniprintModel())->getQuery()
                ->whereNull("stgpelniprint.flagsync")
                ->orWhere("stgpelniprint.flagsync", "<", 1)
                ->offset($start)->limit($limit)->get();
            foreach ($stagings as $stag) {
                if ((new StgpelniprintModel())->saveToOracle($stag)) {
                    $updateStg = self::find($stag->id);
                    $updateStg->flagsync = 1;
                    $updateStg->update();
                }
            }
            if (count($stagings) < $limit) {
                $repeat = false;
            } else {
                $repeat = true;
                $start += $limit;
            }
            if (count($stagings) > 0) {
                $nRepeat++;
            }
        } while ($repeat);
        if ($nRepeat > 0) {
            (new LogsyncoracleModel)->setLogSync("Permintaan Barang - PR", Carbon::now()->toDateTimeString(), "", "success");
        }
    }

    public function saveToOracle($data)
    {
        $query = "INSERT INTO pelni_pr_int (PREPARER_NAME,DESTINATION_TYPE_CODE,ORG_ID,REQ_NUMBER_SEGMENT1,APPROVER_NAME,INTERFACE_SOURCE_CODE,AUTHORIZATION_STATUS,
DOCUMENT_TYPE_CODE,SOURCE_TYPE_CODE,ITEM_ID,ITEM_SEGMENT1,NEED_BY_DATE,QUANTITY, CREATION_DATE, SUBINVENTORY, VOYAGE_CALL, TOTAL_LINE, HEADER_ATTRIBUTE14, HEADER_ATTRIBUTE10, HEADER_ATTRIBUTE9) 
VALUES ('" . $data->preparer_name . "','" . $data->destination_type_code . "','" . $data->org_id . "','" . $data->req_number_segment1 . "',
'" . $data->apprver_name . "','" . $data->interface_source_code . "','" . $data->authorization_status . "','" . $data->document_type_code . "',
'" . $data->source_type_code . "','" . $data->item_id . "','" . $data->item_segment1 . "',
TO_DATE('" . Carbon::parse($data->need_by_date)->format("Y/m/d H:i:s") . "', 'yyyy/mm/dd hh24:mi:ss'),'" . $data->quantity . "',
TO_DATE('" . Carbon::parse($data->creation_date)->format("Y/m/d H:i:s") . "', 'yyyy/mm/dd hh24:mi:ss'), '" . $data->subinventory . "', '" . $data->voyage_call . "', '" . $data->total_line . "', '" . $data->header_attribute14 . "', '" . $data->header_attribute10 . "', '" . $data->header_attribute9 . "')";
        try {
            $oracleOCI = new OracleOCIConnector();
            $oracleOCI->getConnection()->insert($query)->execute();
            (new LogsyncoracleModel)->setLogSync("[ORA]Permintaan Barang : " . $data->req_number_segment1 . " - " . $data->item_segment1 . " - " . $data->org_id, Carbon::now()->toDateTimeString(), "", "posted");

            $oracleOCI->closeConnection();
            return true;
        } catch (\Exception $e) {
            (new LogsyncoracleModel)->setLogSync("[ORA]Permintaan Barang : " . $data->req_number_segment1 . " - " . $data->item_segment1 . " - " . $data->org_id, Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
            return false;
        }
    }
}
